const express = require('express');

module.exports = (logger) => {
  const host = (port) => {
    const app = express();
    const files = {};
    app.use((req, res, next) => {
      logger.debug(`got request for ${req.url}`);
      next();
    });

    app.get('/:name', (req, res) => {
      const { name } = req.params;
      res.end(files[name]);
    });

    app.listen(port, () => {
      logger.debug(`listening on port ${port}`);
    });

    return {
      add: (name, content) => {
        files[name] = content;
      }
    }
  } 

  return host;
};
