const { generateKeyPair } = require('crypto');
const path = require('path');
const ssh = require('./index');

module.exports = (signale, store) => {
  const logger = signale.scope('🗝 keys');
  generateKey = () => new Promise((resolve, reject) => {
    generateKeyPair('rsa', {
      modulusLength: 4096,
      publicKeyEncoding: {
        type: 'spki',
        format: 'pem'
      },
      privateKeyEncoding: {
        type: 'pkcs8',
        format: 'pem',
        cipher: 'aes-256-cbc',
        passphrase: 'topsecret'
      }
    }, (err, publicKey, privateKey) => {
      if (err) {
        return reject(err);
      }
      resolve({
        publicKey,
        privateKey,
      });
    });
  });

  let keys = {};

  const getKeys = async (name = 'default') => {
    const key = `keys_${name}`;
    if (!await store.exists(key)) {
      logger.debug('creating SSH keys');
      const { publicKey, privateKey } = await generateKey();
      await store.set(key, {
        privateKey,
        publicKey,
      });
    } else {
      logger.debug('loading exisiting keys');
    }
    const data = await store.get(key);
    keys = {
      ...data,
      connect: (host, username, options = {}) => ssh(logger)(host, {
        username,
        ...options,
      }),
    };
    return keys;
  }

  return getKeys;
};
