const steps = (logger) => {
  const steps = [];
  const step = (description, fn) => {
    steps.push({
      description,
      fn,
    });
  };

  const run = async () => {
    let data = {};
    for (let i = 0; i < steps.length; i += 1) {
      const { description, fn } = steps[i];
      logger.debug('starting', description);
      const output = await Promise.resolve(fn(data));
      data = {
        ...data,
        ...(output || {}),
      }
    }
  };

  return {
    step,
    runSteps: run,
  };
}

module.exports = steps;