const fs = require('fs-extra');
const path = require('path');

class Store {
  constructor(location = path.join(process.cwd(), 'data.json')) {
    this.location = location;
    if (fs.existsSync(location)) {
      this.data = require(this.location);
    } else {
      this.data = {};
    }
  }

  async set(key, value) {
    this.data[key] = value;
    await fs.writeJSON(this.location, this.data);
  }

  async get(key, value) {
    return this.data[key];
  }

  async exists(key, value) {
    return !!this.data[key];
  }
}

module.exports = Store;